//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SubCls.h"
#include <Dialogs.hpp>

namespace Subcls
{

class TControlSubclassInfo : public Classes::TList
{
  typedef Classes::TList inherited;
  private:
    void __fastcall WndProc(Messages::TMessage &Message);
  public:
    Controls::TControl* Control;
    Controls::TWndMethod OriginalWindowProc;
    HIDESBASE void __fastcall Add(TControlSubclass* ControlSubclass);
    HIDESBASE void __fastcall Remove(TControlSubclass* ControlSubclass);
    /* TList.Destroy */ inline __fastcall virtual ~TControlSubclassInfo(void) { }
    /* TObject.Create */ inline __fastcall TControlSubclassInfo(void) : Classes::TList() { }
};


void __fastcall  TControlSubclassInfo::Add(TControlSubclass* ControlSubclass)
{
  Control->WindowProc = WndProc;
  TList::Add(ControlSubclass);
}

void __fastcall  TControlSubclassInfo::Remove(TControlSubclass* ControlSubclass)
{
  TList::Remove(ControlSubclass);
  if (Count == 0)
    Control->WindowProc = OriginalWindowProc;
}

void __fastcall  TControlSubclassInfo::WndProc(Messages::TMessage &Message)
{
  if (Count > 0)
    for (int i=0; i<Count; ++i)
      if (Items[i])
        ((TControlSubclass *)(Items[i]))->BeforeWndProc(Control, Message);

  if (OriginalWindowProc)
    OriginalWindowProc(Message);

  if (Message.Msg != CM_RELEASE)
  {
   if (Count > 0)
     for (int i=0; i<Count; ++i)
       if (Items[i])
         ((TControlSubclass *)(Items[i]))->AfterWndProc(Control, Message);
  }
}

class TControlSubclassList : public Classes::TList
{
  public :
    int __fastcall FindControl(TControl* Control);
    void __fastcall Add(TControl* Control, TControlSubclass *ControlSubclass);
    void __fastcall Remove(TControl* Control, TControlSubclass *ControlSubclass);
} *ControlSubclassList = new TControlSubclassList();


int __fastcall TControlSubclassList::FindControl(TControl* Control)
{
  int Result = -1;
  if (Count > 0)
    for (int i = 0; i<Count; ++i)
      if (  ((TControlSubclassInfo *)Items[i])->Control  == Control)
      {
        Result = i;
        break;
      }
  return Result;
}

void __fastcall TControlSubclassList::Add(TControl* Control, TControlSubclass *ControlSubclass)
{
 int i = FindControl(Control);
 TControlSubclassInfo *ControlSubclassInfo;

 if (i < 0)
 {
    ControlSubclassInfo = new TControlSubclassInfo();
    ControlSubclassInfo->Control = Control;
    ControlSubclassInfo->OriginalWindowProc = Control->WindowProc;
    TList::Add(ControlSubclassInfo);
  }
 else
   ControlSubclassInfo = (TControlSubclassInfo *)Items[i];

 ControlSubclassInfo->Add(ControlSubclass);
}

void __fastcall TControlSubclassList::Remove(TControl* Control, TControlSubclass *ControlSubclass)
{
 int i = FindControl(Control);

 if (i < 0)
   return;

 TControlSubclassInfo *ControlSubclassInfo = (TControlSubclassInfo *)Items[i];
 ControlSubclassInfo->Remove(ControlSubclass);

 if (ControlSubclassInfo->Count == 0)
 {
   TList::Remove(ControlSubclassInfo);
   delete ControlSubclassInfo;
 }
}

void __fastcall RegisterSubclass(Controls::TControl* Control, TControlSubclass* Subclass)
{
  ControlSubclassList->Add(Control, Subclass);
}

void __fastcall UnRegisterSubclass(Controls::TControl* Control, TControlSubclass* Subclass)
{
  ControlSubclassList->Remove(Control, Subclass);
}
}
//---------------------------------------------------------------------------

#pragma package(smart_init)
