//---------------------------------------------------------------------------

#ifndef SubClsH
#define SubClsH

#include <Messages.hpp>
#include <Windows.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>


/******************************************************************************/
/***              SubCls - TWinControl subclass helper                      ***/
/******************************************************************************/

/*
 TControlSubclass is an abstract ancestor for objects that implement a message
  handling method for a control. To handle methods for a control in a component
  you should create a new class, derived from TControlSubclass, and handle the
  messages in the ...WndProc functions.
*/


//-- user supplied -----------------------------------------------------------

namespace Subcls
{
//-- type declarations -------------------------------------------------------
class TControlSubclass;
class TControlSubclass : public System::TObject
{
  typedef System::TObject inherited;
  public:
    inline virtual void __fastcall BeforeWndProc(Controls::TControl* Control, Messages::TMessage &Message) {};
    inline virtual void __fastcall AfterWndProc(Controls::TControl* Control, Messages::TMessage &Message) {};
    inline __fastcall TControlSubclass(void) : System::TObject() { }
    inline __fastcall virtual ~TControlSubclass(void) { }
};


extern PACKAGE void __fastcall RegisterSubclass(Controls::TControl* Control, TControlSubclass* Subclass);
extern PACKAGE void __fastcall UnRegisterSubclass(Controls::TControl* Control, TControlSubclass* Subclass);

} /* namespace Subcls */

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
  using namespace Subcls;
#endif

#endif	// SubCls
