{------------------------------------------------------------------------------}
{ TJBFrom v1.00                                                                }
{------------------------------------------------------------------------------}
{ A new form adding a lot of new functionallity to you forms, just by making   }
{ your form inherits form TJBFrom in stead of TForm. Se Demo for details       |
{                                                                              }
{ Copyright 2002, Jens Borrisholt.  All Rights Reserved.                       }
{                                                                              }
{ Copyright:                                                                   }
{ All Delphi Free Stuff (hereafter "DFS") source code is copyrighted by        }
{ Jens Borrosholt (hereafter "author"), and shall remain the exclusive         }
{ property of the author.                                                      }
{                                                                              }
{ Distribution Rights:                                                         }
{ You are granted a non-exlusive, royalty-free right to produce and distribute }
{ compiled binary files (executables, DLLs, etc.) that are built with any of   }
{ the DFS source code unless specifically stated otherwise.                    }
{ You are further granted permission to redistribute any of the DFS source     }
{ code in source code form, provided that the original archive as found on the }
{ DFS web site (http://www.delphifreestuff.com) is distributed unmodified.     }
{                                                                              }
{ Restrictions:                                                                }
{ Without the express written consent of the author, you may not:              }
{   * Distribute modified versions of any DFS source code by itself. You must  }
{     include the original archive as you found it at the DFS site.            }
{   * Sell or lease any portion of DFS source code. You are, of course, free   }
{     to sell any of your own original code that works with, enhances, etc.    }
{     DFS source code.                                                         }
{   * Distribute DFS source code for profit.                                   }
{                                                                              }
{ Warranty:                                                                    }
{ There is absolutely no warranty of any kind whatsoever with any of the DFS   }
{ source code (hereafter "software"). The software is provided to you "AS-IS", }
{ and all risks and losses associated with it's use are assumed by you. In no  }
{ event shall the author of the softare, Jens Borrisholt, be held              }
{ accountable for any damages or losses that may occur from use or misuse of   }
{ the software.                                                                }
{                                                                              }
{ Support:                                                                     }
{ Support is provided via E-Mail, Jens@Borrisholt.com or by                    }
{ www.eksperten.dk Support Forum, which is a web-based message system.         }
{ All DFS source code is provided free of charge. As such, I can not guarantee }
{ any support whatsoever. While I do try to answer all questions that I        }
{ receive and address all problems that are reported to me, you must           }
{ understand that I simply can not guarantee that this will always be so.      }
{                                                                              }
{ Clarifications:                                                              }
{ If you need any further information, please feel free to contact me directly.}
{------------------------------------------------------------------------------}
{ Date last modified:  August  04, 2002                                        }
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
{ Revision History:                                                            }
{                                                                              }
{ 04-08-2002  :                                                                }
{      V 1.00  Project created.                                                }
{------------------------------------------------------------------------------}

{:
  This is not a component it is a new form.

  This new form adding a lot of new functionallity to you forms, just by making
  your form inherits form TJBFrom instead of TForm. You can do that to "new"
  forms, or you can even use it in a project you are working on.

  TJBFrom is easy tou use, alle there realy are in to it a two steps :

  1)
   Delphi :
     Add UnitJBForm to you uses clausule, in the top of the unit contaning
     your form.
   C++ Builder :
     #include "UnitJBForm.h" in thw headder file contaning the interface for
     your form.
  2)
   Make your form inherits TJBForm instead of TForm.

   Delphi :
     Go to the definition of your form change
     TForm1 = class(TForm) to TForm1 = class(TJBForm)
   C++ Builder :
     A)
     Go to the headder file contaning the definition of your form change
     class TForm1 : public TForm to class TForm1 : public TJBForm

     B)
     Go to the refering cpp file (by pressing [ctrl] +[F6] anf find the constructor
     for you from. change

     __fastcall TForm1::TForm1(TComponent* Owner)  : TForm(Owner)

     to
     __fastcall TForm1::TForm1(TComponent* Owner)  : TJBForm(Owner)


   if you like the product, or make changer, and/or bug fixes then please tell me
   about it by contacting me direct : Jens@Borrisholt.com
:}



unit UnitJBForm;

interface
uses
   Windows, Forms, Classes, Messages, SubCls, Controls;

type
  TPercent = 0..100;
  TJBForm = class;

  TMyControlSubclass = class(TControlSubclass)
  private
    LbDown : boolean;
    OldP, OldQ  : TPoint;
    JBForm  : TJBForm;
    Timer1, Timer2 : Boolean;
    function GetParentForm(Control: TControl) : TJBForm;
    function SetTimer(hWnd: HWND; nIDEvent, uElapse: UINT;lpTimerFunc: TFNTimerProc): UINT;
    function KillTimer(hWnd: HWND; uIDEvent: UINT): BOOL;
  protected
    procedure BeforeWndProc(Control: TControl; var Message: TMessage); override;
    procedure AfterWndProc(Control: TControl; var Message: TMessage); override;

    procedure doMouseDown;
    procedure doMouseMove;
    procedure doMouseUp;
    procedure doNcMouseMove;

    procedure doBlendUp;
    procedure doBlendDown;
  public
    Constructor Create;
  end;

  TJBForm = class(TForm)
  private
    FShowCaption     : Boolean;
    FSnapToEdge      : Boolean;
    FMargin          : TPercent;
    FSubclass        : TMyControlSubclass;
    FTransparency    : Integer;
    FUseTransparency : Boolean;
    FMoveFormByControls: Boolean;
    procedure SetMargin(const Value: TPercent);
    procedure SetSnapToEdge(const Value: Boolean);
    procedure SetShowCaption(const Value: Boolean);
    procedure SetTransparency(const Value: Integer);
    procedure SetUseTransparency(const Value: Boolean);
    procedure SetMoveFormByControls(const Value: Boolean);
  public
    constructor Create(AOwner : TComponent); override;
    destructor  Destroy; override;
  published
    property ShowCaption        : Boolean  read FShowCaption        write SetShowCaption;
    property SnapToEdge         : Boolean  read FSnapToEdge         write SetSnapToEdge;
    property Margin             : TPercent read FMargin             write SetMargin default 2;
    property Transparency       : Integer  read FTransparency       write SetTransparency;
    property UseTransparency    : Boolean  read FUseTransparency    write SetUseTransparency;
    property MoveFormByControls : Boolean  read FMoveFormByControls write SetMoveFormByControls;
  end;

implementation
uses
  SysUtils;

{TJBForm }

Const
  WS_EX_LAYERED = $00080000;
  LWA_COLORKEY  = $00000001;
  LWA_ALPHA     = $00000002;
  ULW_COLORKEY  = $00000001;
  ULW_ALPHA     = $00000002;

Type
  PBlendFunction = ^TBlendFunction;
  TBlendFunction = Packed Record
    BlendOp             : Byte;
    BlendFlags          : Byte;
    SourceConstantAlpha : Byte;
    AlphaFormat         : Byte;
  End;

Function SetLayeredWindowAttributes(hWnd : hWnd; crKey : TColorRef; bAlpha : Byte;
                                    dwFlags : Integer) : Integer; StdCall;
                                    External User32 Name 'SetLayeredWindowAttributes';

Function UpdateLayeredWindow(hWnd : hWnd; hdcDst : hDC; pptDst : PPoint; psize : PSize; hdcSrc : hDC;
                             pptSrc : PPoint; crKey : TColorRef; pblend : PBlendFunction;
                             dwFlags : Integer) : Integer; StdCall;
                             External User32 Name 'UpdateLayeredWindow';

constructor TJBForm.Create(Aowner: TComponent);
var
  i : Integer;
begin
  inherited;
  SetWindowLong(Handle,GWL_EXSTYLE,GetWindowLong(Handle,GWL_EXSTYLE) Or WS_EX_LAYERED);
  Transparency := 255;
  FUseTransparency := true;
  FShowCaption := true;
  FMargin := 2;
  FSnapToEdge := true;
  FMoveFormByControls := true;

  FSubclass := TMyControlSubclass.Create;
  RegisterSubclass(TControl(Self), FSubclass);

  for i := 0 to ComponentCount - 1 do
    if (Components[i] is TControl) then
      RegisterSubclass(Components[i] as TControl, FSubclass);
end;

destructor TJBForm.Destroy;
var
  i : Integer;
begin
  for i := 0 to ComponentCount - 1 do
    if Components[i] is TControl then
      UnRegisterSubclass(Components[i] as TControl, FSubclass);

  UnRegisterSubclass(TControl(Self), FSubclass);
  FreeAndNil(FSubclass);
  inherited;
end;

procedure TJBForm.SetMargin(const Value: TPercent);
begin
  FMargin := Value;
end;

procedure TJBForm.SetMoveFormByControls(const Value: Boolean);
begin
  FMoveFormByControls := Value;
end;

procedure TJBForm.SetShowCaption(const Value: Boolean);
begin
  FShowCaption := Value;
  if not FShowCaption then
  begin
    SetWindowLong(Handle,GWL_STYLE, GetWindowLong(Handle, GWL_Style) and not WS_Caption);
    Height := Height - GetSystemMetrics(SM_CYCAPTION);
  end
  else
  begin
    SetWindowLong(Handle,GWL_STYLE, GetWindowLong(Handle, GWL_Style) or WS_Caption);
    Height := Height + GetSystemMetrics(SM_CYCAPTION);
  end;
end;

procedure TJBForm.SetSnapToEdge(const Value: Boolean);
begin
  FSnapToEdge := Value;
end;

procedure TJBForm.SetTransparency(const Value: Integer);
begin
  if FTransparency = Value then
    exit;
  FTransparency := Value;
  SetLayeredWindowAttributes(Handle,0,FTransparency,LWA_ALPHA);
end;

procedure TJBForm.SetUseTransparency(const Value: Boolean);
begin
  FUseTransparency := Value;
end;

{ TMyControlSubclass }

procedure TMyControlSubclass.AfterWndProc(Control: TControl;  var Message: TMessage);
begin
end;

procedure TMyControlSubclass.BeforeWndProc(Control: TControl; var Message: TMessage);
begin
  JbForm := GetParentForm(Control);
  if Control is TComponent then
    if (Control as TComponent).Tag <> 0 then
      exit;


  case Message.Msg of
    WM_TIMER :
      case  Message.WParam of
      1:
        doBlendDown;
      2:
        doBlendUp;
     end;

    WM_NCLBUTTONDOWN :
      doMouseDown;
    WM_NCMOUSEMOVE :
    begin
      doNcMouseMove;
      doMouseUp;
    end;
  end;

  if not JbForm.FMoveFormByControls then
    exit;

  case Message.Msg of
    WM_LBUTTONDOWN :
      doMouseDown;
    WM_LBUTTONUP :
      doMouseUp;
    WM_MOUSEMOVE:
      doMouseMove;
  end;
end;

constructor TMyControlSubclass.Create;
begin
  inherited;
  Timer1 := False;
  Timer2 := False;
end;

procedure TMyControlSubclass.doBlendDown;
begin
  with JBForm do
  begin
    Transparency := Transparency - 10;
    if Transparency < 155 then
       KillTimer(Handle, 1);
  end;
end;

procedure TMyControlSubclass.doBlendUp;
begin
  with JBForm do
  begin
    Transparency := Transparency + 10;
    if Transparency > 255 then
      Transparency := 255;

    if Transparency = 255 then
       KillTimer(Handle, 2);
  end;
end;
procedure TMyControlSubclass.doNcMouseMove;
begin
  if (Timer1 or Timer2) then
    exit;
  if not LbDown then
   exit;

  LbDown := false;

  with JBForm do
  begin
    if not FUseTransparency then
      Exit;

    KillTimer(Handle, 1);
    KillTimer(Handle, 2);
    SetTimer(Handle, 2, 20, nil);
  end;
end;

procedure TMyControlSubclass.doMouseDown;
begin
  LBDown := True;
  OldP.X:= Mouse.CursorPos.X;
  OldP.Y:= Mouse.CursorPos.Y;
  OldQ:=OldP;


  with JBForm do
  begin
    if not FUseTransparency then
      Exit;

    KillTimer(Handle, 1);
    KillTimer(Handle, 2);
    SetTimer(Handle, 1, 20, nil);
  end;
end;

procedure TMyControlSubclass.doMouseMove;
var
  Q : TPoint;
begin
  if Not LBDown then
    exit;

  Q.X := Mouse.CursorPos.X;
  Q.Y := Mouse.CursorPos.Y;

  if (Q.X<>OldQ.X) or (Q.Y<>OldQ.Y) then
  begin
    with JBForm do
    begin
      Left := Left + (Q.X-OldQ.X);
      Top  := Top  + (Q.Y-OldQ.Y);
    end;
  end;
  OldQ:=Q;
end;

procedure TMyControlSubclass.doMouseUp;
var
  SnapMargin : Real;
begin
  LBDown := False;

  with JBForm do
  begin
    if not FUseTransparency then
      Exit;

    KillTimer(Handle, 1);
    KillTimer(Handle, 2);
    SetTimer(Handle, 2, 20, nil);
  end;

  if not JBForm.FSnapToEdge then
    exit;

  SnapMargin := JBForm.FMargin / 100.0;

  with JBForm do
  begin
    If Screen.Width - (Left + ClientWidth)  <= (SnapMargin * Screen.Width) then
      MoveWindow(Handle, Screen.Width - ClientWidth, Top, Width, Height, True);

    If Screen.Height - (Top + ClientHeight) <= (SnapMargin * Screen.Height) then
      MoveWindow(Handle, Left, Screen.Height - ClientHeight, Width, Height, True);

    If Left <= Screen.Width * SnapMargin then
      MoveWindow(Handle, 0, Top, Width, Height, True);

    If Top <= Screen.Height * SnapMargin then
      MoveWindow(Handle, Left, 0, Width, Height, True);
  end;
end;


function TMyControlSubclass.GetParentForm(Control: TControl): TJBForm;
begin
  Result := TJBForm(Forms.GetParentForm(Control));
end;

function TMyControlSubclass.KillTimer(hWnd: HWND; uIDEvent: UINT): BOOL;
begin
  Result := Windows.KillTimer(hWnd, uIDEvent);
  case uIDEvent of
    1:  Timer1 := False;
    2: Timer2 := False;
  end;
end;

function TMyControlSubclass.SetTimer(hWnd: HWND; nIDEvent, uElapse: UINT;  lpTimerFunc: TFNTimerProc): UINT;
begin
  Result := Windows.SetTimer(hWnd, nIDEvent, uElapse, lpTimerFunc);

  case nIDEvent of
    1: Timer1 := True;
    2: Timer2 := True;
  end;
end;

end.
